unit GPIOTestUnit;

{$mode objfpc}{$H+}

interface

uses Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls, Unix, LowLevelGPIO;

const
  INPUT = 0;
  OUTPUT = 1;
  GPIO17 = 17;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure PrepareGPIO;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  GPIODriver: TIoDriver;
  GPIO: TIoPort;

implementation

{$R *.frm}

procedure TForm1.PrepareGPIO;
begin
  if GPIODriver=nil then GPIODriver:= TIoDriver.Create;

  if GPIODriver.MapIO then
    begin
      GPIO := GpIoDriver.CreatePort(GPIO_BASE,CLOCK_BASE,GPIO_PWM);
      if GPIO<>NIL then
      GPIO.SetPinMode(GPIO17,Output);

      MessageDlg('GPIO OK','======= ALL OK ===========',mtError,[mbOK],0);
    end
  else MessageDlg('GPIO Error','Unable to map GPIO to memory.',mtError,[mbOK],0);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  //PrepareGPIO;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  GPIO.SetBit(GPIO17);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  GPIO.ClearBit(GPIO17);
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  if GPIODriver<>nil then
     GPIODriver.UnmapIoRegisrty(GPIO);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  PrepareGPIO;
end;


end.
